<template>
    <div class="list-page faq-table">
        <h2 class="list-pageH2 wow fadeInLeft">{{ $t('faq_items.title') }}</h2>
        <div class="box-table">
            <div class="table-head wow fadeInUp">
                <p class="text-p">{{ $t('faq_items.table.question') }}</p>
                <p class="text-p">{{ $t('faq_items.table.answer') }}</p>
            </div>
            <div class="box-table--body wow fadeInUp" v-for="faq_item in faq_items">
                <p class="text-one">{{ faq_item.question[locale] }}</p>
                <p class="text-two">{{ faq_item.answer[locale] }}</p>
                <div class="box__body--right">
                    <svg class="look" :class="{'is-hidden' : faq_item.hidden}" @click="toggleHidden(faq_item.id)">
                        <use xlink:href="/img/sprite.svg#private"/>
                    </svg>
                    <router-link :to="route('faq_edit', {id: faq_item.id})">
                        <svg class="edit">
                            <use xlink:href="/img/sprite.svg#edit"/>
                        </svg>
                    </router-link>
                    <svg class="delete" @click="deleteFaqItem(faq_item.id)">
                        <use xlink:href="/img/sprite.svg#cancel-button"/>
                    </svg>
                </div>
            </div>
            <paginator
                :current-page="currentPage"
                :last-page="lastPage"
                :per-page="perPage"
                :items-count="total"
                @page-changed="setPage"
            />
        </div>
    </div>
</template>

<script>
import {mapGetters} from "vuex";
import route from "../../mixins/route";

export default {
    name: "FaqTable",
    mixins: [route],
    data() {
        return {
            currentPage: 0,
            lastPage: 0,
            perPage: 0,
            total: 0,
            page: 1,
            faq_items: [],
        }
    },
    computed: {
        ...mapGetters([
            'axios',
            'locale'
        ])
    },
    methods: {
        submit() {
            this.axios.get(`faq_items`, {
                params: {
                    page: this.page,
                }
            })
                .then(resp => resp.data)
                .then(faq_items => {
                    console.log(faq_items);
                    this.currentPage = faq_items.current_page;
                    this.lastPage = faq_items.last_page;
                    this.perPage = faq_items.per_page;
                    this.total = faq_items.total;
                    this.faq_items = faq_items.data;
                });
        },
        deleteFaqItem(id) {
            this.axios
                .post(`faq_items/${id}/delete`)
                .then(resp => resp.data)
                .then(data => {
                    if ('success' === data.status) {
                        this.$swal('Страница удалена');
                    } else {
                        this.$swal(this.$t('ui.error'), '', 'error')
                    }
                });
        },
        toggleHidden(id) {
            this.axios
                .get(`faq_items/${id}/toggleHidden`)
                .then(resp => resp.data)
                .then(data => {
                    if ('success' === data.status) {
                        this.$swal(data.item.hidden ? 'Запись скрыта' : 'Запись отображается');
                    } else {
                        this.$swal(this.$t('ui.error'), '', 'error')
                    }
                })
                .then(() => this.submit());
        },
        setPage(page) {
            this.page = page;
            this.submit();
        },
    },
    mounted() {
        this.submit();
    },
}
</script>

<style scoped lang="scss">
.faq-table {
    margin-top: 0;

    .box-table {
        .table-head .text-p {
            margin-right: 40%;
        }

        .box-table--body {
            .text-one, .text-two {
                flex-basis: 35%;
                color: #4b4b4b;
                font-size: 14px;
                font-weight: 400;
                line-height: 15px;
                margin-right: 143px;
            }

            .box__body--right .look.is-hidden {
                fill: #2b5ede;

                &:hover {
                    fill: #c6c6c6;
                }
            }
        }
    }
}
</style>
